using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Kronos.General;
using Exferia_Kronos._1_Modelos;
using static Exferia_Aplicacion.General.Enumerados;
using Exferia_EntityFramework;

namespace Exferia_Kronos._4_Vistas.Listados
{
    public class ABS_Listado_KRO_TareasProgramadas_Historico : ABS_Listado
    {
        //Variables privadas
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();
        private INTERNO_ValoresGenerales_Modelo g_mdl_INTERNO_ValoresGenerales_Modelo;

        //Constructor
        public ABS_Listado_KRO_TareasProgramadas_Historico(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo)
        {
            g_mdl_INTERNO_ValoresGenerales_Modelo = _mdl_INTERNO_ValoresGenerales_Modelo;

            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //fechaHoraInicio
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.fechaHoraInicio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.fechaHoraInicio), "Fecha Inicio", G_ENUM_TIPOSDATOS.DATETIME, false, 100, true, true, true, false, "", null));

            //fechaHoraFin
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.fechaHoraFin), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.fechaHoraFin), "Fecha Fin", G_ENUM_TIPOSDATOS.DATETIME, false, 100, true, true, true, false, "", null));

            //resultado
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.resultado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false,nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.resultado), "Resultado",G_ENUM_TIPOSDATOS.TEXT,false, 150, true,false,true,false,"",null));

            //fechaHoraTareaProgramada
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.fechaHoraTareaProgramada), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.fechaHoraTareaProgramada), "Fecha Tarea Programada", G_ENUM_TIPOSDATOS.DATETIME, false, 100, true, false, false, false, "", null));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_KRO_TAREAPROGRAMADA_HISTORICO);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_KRO_TAREAPROGRAMADA_HISTORICO;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_KRO_TareasProgramadas_Historico_Listado_Modelo.fechaHoraInicio);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
